Index: TOOLS/WATER_BUDGET/OCE_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/OCE_waterbudget.py	(revision 6446)
+++ TOOLS/WATER_BUDGET/OCE_waterbudget.py	(revision 6508)
@@ -24,6 +24,15 @@
 import numpy as np
 import configparser, re
-
-## Creates parser
+from pathlib import Path
+
+## Import local module
+import WaterUtils as wu
+
+# Check python version
+if sys.version_info < (3, 8, 0) :
+    print ( f'Python version : {platform.python_version()}' ) 
+    raise Exception ( "Minimum Python version is 3.8" )
+
+## Creates parser for reading .ini input file
 config = configparser.ConfigParser()
 config.optionxform = str # To keep capitals
@@ -33,129 +42,58 @@
 
 ##
-ARCHIVE=None ; STORAGE = None ; SCRATCHDIR=None ; R_IN=None ; rebuild=None
-TmpDir=None ; FileOut=None ; dir_ATM_his=None ; dir_SRF_his=None ; dir_OCE_his=None ; dir_ICE_his=None ; FileCommon=None
+ARCHIVE=None ; STORAGE = None ; SCRATCHDIR=None ; R_IN=None ; rebuild='rebuild_nemo'
+TmpDir=None ; RunDir=None ; FileOut=None ; dir_ATM_his=None ; dir_SRF_his=None ; dir_OCE_his=None ; dir_ICE_his=None ; FileCommon=None
 file_ATM_his=None ; file_SRF_his=None ; file_RUN_his=None ; file_OCE_his=None ;  file_ICE_his=None ; file_OCE_sca=None 
-file_restart_beg=None ; file_restart_end=None ; file_ATM_beg=None ; file_ATM_end=None ; file_DYN_beg=None ; file_DYN_end=None ; file_SRF_beg=None ; file_SRF_end=None
+tar_restart_beg=None ; tar_restart_end=None ; file_ATM_beg=None ; file_ATM_end=None ; file_DYN_beg=None ; file_DYN_end=None ; file_SRF_beg=None ; file_SRF_end=None
 file_RUN_beg=None ; file_RUN_end=None ; file_OCE_beg=None ; file_ICE_beg=None ; file_OCE_end=None ; file_ICE_end=None
-
-# Arguments passed
+ContinueOnError=False ; ErrorCount=0
+tar_restart_beg_ATM=None ; tar_restart_beg_DYN=None ; tar_restart_beg_SRF=None ; tar_restart_beg_RUN=None ; tar_restart_beg_OCE=None ; tar_restart_beg_ICE=None
+tar_restart_end_ATM=None ; tar_restart_end_DYN=None ; tar_restart_end_SRF=None ; tar_restart_end_RUN=None ; tar_restart_end_OCE=None ; tar_restart_end_ICE=None
+
+# Read command line arguments
 print ( "Name of Python script:", sys.argv[0] )
 IniFile = sys.argv[1]
+# Text existence of IniFile
+print ("Input file : ", IniFile )
+
+if 'full' in IniFile : FullIniFile = IniFile
+else                 : FullIniFile = 'full_' + IniFile
+
 print ("Input file : ", IniFile )
 config.read (IniFile)
-if 'full' in IniFile : FullIniFile = IniFile
-else                 : FullIniFile = 'full_' + IniFile
-
-def setBool (chars) :
-    '''Convert specific char string in boolean if possible'''
-    setBool = chars
-    for key in configparser.ConfigParser.BOOLEAN_STATES.keys () :
-        if chars.lower() == key : setBool = configparser.ConfigParser.BOOLEAN_STATES[key]
-    return setBool
-
-def setNum (chars) :
-    '''Convert specific char string in integer or real if possible'''
-    if type (chars) == str :
-        realnum = re.compile ("^[-+]?[0-9]*\.?[0-9]+(e[-+]?[0-9]+)?$")
-        isReal = realnum.match(chars.strip()) != None
-        isInt  = chars.strip().isdigit()
-        if isReal :
-            if isInt : setNum = int   (chars)
-            else     : setNum = float (chars)
-        else : setNum = chars
-    else : setNum = chars
-    return setNum
-
-def setNone (chars) :
-    '''Convert specific char string to None if possible'''
-    if type (chars) == str :
-        if chars in ['None', 'NONE', 'none'] : setNone = None
-        else : setNone = chars
-    else : setNone = chars
-    return setNone
-
-## Reading config
+FullIniFile = 'full_' + IniFile
+    
+## Reading config file
 for Section in ['Experiment', 'libIGCM', 'Files', 'Physics' ] :
-    if Section in config.keys() : 
-        print ( f'[{Section}]' )
+   if Section in config.keys () : 
+        print ( f'Reading [{Section}]' )
         for VarName in config[Section].keys() :
             locals()[VarName] = config[Section][VarName]
-            locals()[VarName] = setBool (locals()[VarName])
-            locals()[VarName] = setNum  (locals()[VarName])
+            exec ( f'{VarName} = wu.setBool ({VarName})' )
+            exec ( f'{VarName} = wu.setNum  ({VarName})' )
+            exec ( f'{VarName} = wu.setNone ({VarName})' )
+            exec ( f'wu.{VarName} = {VarName}' )
             print ( '{:25} set to : {:}'.format (VarName, locals()[VarName]) )
-
+            #exec ( f'del {VarName}' )
+
+#-- Some physical constants
+if wu.unDefined ( 'Ra' )           : Ra          = 6366197.7236758135 #-- Earth Radius (m)
+if wu.unDefined ( 'Grav' )         : Grav        = 9.81               #-- Gravity (m^2/s
+if wu.unDefined ( 'ICE_rho_ice' )  : ICE_rho_ice = 917.0              #-- Ice volumic mass (kg/m3) in LIM3
+if wu.unDefined ( 'ICE_rho_sno')   : ICE_rho_sno = 330.0              #-- Snow volumic mass (kg/m3) in LIM3
+if wu.unDefined ( 'OCE_rho_liq' )  : OCE_rho_liq = 1026.0             #-- Ocean water volumic mass (kg/m3) in NEMO
+if wu.unDefined ( 'ATM_rho' )      : ATM_rho     = 1000.0             #-- Water volumic mass in atmosphere (kg/m^3)
+if wu.unDefined ( 'SRF_rho' )      : SRF_rho     = 1000.0             #-- Water volumic mass in surface reservoir (kg/m^3)
+if wu.unDefined ( 'RUN_rho' )      : RUN_rho     = 1000.0             #-- Water volumic mass of rivers (kg/m^3)
+if wu.unDefined ( 'ICE_rho_pnd' )  : ICE_rho_pnd = 1000.              #-- Water volumic mass in ice ponds (kg/m^3)
+if wu.unDefined ( 'YearLength' )   : YearLength  = 365.25 * 24. * 60. * 60. #-- Year length (s)
+
+# Set libIGCM and machine dependant values
 if not 'Files' in config.keys() : config['Files'] = {}
-
-def unDefined (char) :
-    if char in globals () :
-        if char == None : return True
-        else : return False
-    else : return True
-
-##-- Some physical constants
-#-- Earth Radius
-if not 'Ra'            in locals () : Ra = 6366197.7236758135
-#-- Gravity
-if not 'Grav'          in locals () : Grav = 9.81
-#-- Ice volumic mass (kg/m3) in LIM3
-if not 'ICE_rho_ice'   in locals () : ICE_rho_ice = 917.0
-#-- Snow volumic mass (kg/m3) in LIM3
-if not 'ICE_rho_sno'   in locals () : ICE_rho_sno = 330.0
-    #-- Water density in ice pounds in SI3
-if not 'ICE_rho_pnd'   in locals () : ICE_rho_pnd = 1000.
-#-- Ocean water volumic mass (kg/m3) in NEMO
-if not 'OCE_rho_liq'   in locals () : OCE_rho_liq = 1026.
-#-- Water volumic mass in atmosphere
-if not 'ATM_rho'       in locals () : ATM_rho = 1000.
-#-- Water volumic mass in surface reservoirs
-if not 'SRF_rho'       in locals () : SRF_rho = 1000.
-#-- Water volumic mass of rivers
-if not 'RUN_rho'       in locals () : RUN_rho = 1000.
-#-- Year length
-if not 'YearLength'    in locals () : YearLength = 365.25 * 24. * 60. * 60.
-
-config['Physics'] = { 'Ra':Ra, 'Grav':Grav, 'ICE_rho_ice':ICE_rho_ice, 'ICE_rho_sno':ICE_rho_sno, 'OCE_rho_liq':OCE_rho_liq, 'ICE_rho_pnd':ICE_rho_pnd,
-                          'ATM_rho':ATM_rho, 'SRF_rho':SRF_rho, 'RUN_rho':RUN_rho}
+    
+config['Physics'] = { 'Ra':Ra, 'Grav':Grav, 'ICE_rho_ice':ICE_rho_ice, 'ICE_rho_sno':ICE_rho_sno, 'OCE_rho_liq':OCE_rho_liq, 'ATM_rho':ATM_rho, 'SRF_rho':SRF_rho, 'RUN_rho':RUN_rho}
         
-
-
-# Where do we run ?
-SysName, NodeName, Release, Version, Machine = os.uname()
-TGCC  = ( 'irene'   in NodeName )
-IDRIS = ( 'jeanzay' in NodeName )
-
-## Set site specific libIGCM directories, and other specific stuff
-if TGCC :
-    CPU = subprocess.getoutput ( 'lscpu | grep "Model name"' )
-    if "Intel(R) Xeon(R) Platinum" in CPU : Machine = 'irene'
-    if "AMD"                       in CPU : Machine = 'irene-amd'
-        
-    ARCHIVE     = subprocess.getoutput ( f'ccc_home --cccstore   -d {Project} -u {User}' )
-    STORAGE     = subprocess.getoutput ( f'ccc_home --cccwork    -d {Project} -u {User}' )
-    SCRATCHDIR  = subprocess.getoutput ( f'ccc_home --cccscratch -d {Project} -u {User}' )
-    R_IN        = os.path.join ( subprocess.getoutput ( f'ccc_home --cccwork -d igcmg -u igcmg'), 'IGCM')
-    rebuild     = os.path.join ( subprocess.getoutput ( f'ccc_home --ccchome -d igcmg -u igcmg'), 'Tools', Machine, 'rebuild_nemo', 'bin', 'rebuild_nemo' )
-
-    ## Specific to run at TGCC.
-    # Needed before importing a NetCDF library (netCDF4, xarray, cmds, etc ...)
-    import mpi4py
-    mpi4py.rc.initialize = False
-        
-    ## Creates output directory
-    TmpDir = os.path.join ( subprocess.getoutput ( 'ccc_home --cccscratch' ), f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
-
-if IDRIS :
-    raise Exception ("Pour IDRIS : repertoires et chemins a definir") 
-
-config['System'] = {'SysName':SysName, 'NodeName':NodeName, 'Release':Release, 'Version':Version,'Machine':Machine, 'TGCC':TGCC,'IDRIS':IDRIS, 'CPU':CPU,
-                    'Program'  : "Generated by : " + str(sys.argv), 
-                    'HOSTNAME' : platform.node (), 'LOGNAME'  : os.getlogin (),
-                    'Python'   : f'{platform.python_version ()}',
-                    'OS'       : f'{platform.system ()} release : {platform.release ()} hardware : {platform.machine ()}',
-                    'SVN_Author'   : "$Author$", 
-                    'SVN_Date'     : "$Date$",
-                    'SVN_Revision' : "$Revision$",
-                    'SVN_Id'       : "$Id$",
-                    'SVN_HeadURL'  : "$HeadURL$"}
+with open ('SetLibIGCM.py') as f: exec ( f.read() )
+config['Files']['TmpDir'] = TmpDir
 
 if libIGCM :
@@ -167,13 +105,35 @@
 import xarray as xr
     
-# Output file
-if FileOut == None : 
-    FileOut = f'OCE_waterbudget_{JobName}_{YearBegin}_{YearEnd}.out'
-    config['Files']['FileOut'] = FileOut
+# Output file with water budget diagnostics
+if wu.unDefined ( 'FileOut' ) : FileOut = f'OCE_waterbudget_{JobName}_{YearBegin}_{YearEnd}.out'
+config['Files']['FileOut'] = FileOut
 
 f_out = open ( FileOut, mode = 'w' )
-    
-# Function to print to stdout *and* output file
+
+# Useful functions
+def kg2Sv    (val, rho=ATM_rho) :
+    '''From kg to Sverdrup'''
+    return val/dtime_sec*1.0e-6/rho
+
+def kg2myear (val, rho=ATM_rho) :
+    '''From kg to m/year'''
+    return val/ATM_aire_sea_tot/rho/NbYear
+
+def var2prt (var, small=False, rho=ATM_rho) :
+    if small :  return var , kg2Sv(var, rho=rho)*1000., kg2myear(var, rho=rho)*1000.
+    else     :  return var , kg2Sv(var, rho=rho)      , kg2myear(var, rho=rho)
+
+def prtFlux (Desc, var, Form='F', small=False, rho=ATM_rho, width=15) :
+    if small :
+        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} mSv | {:12.4f} mm/year "
+        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} mSv | {:12.4e} mm/year "
+    else :
+        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} Sv  | {:12.4f} m/year  "
+        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} Sv  | {:12.4e} m/year  "
+    echo ( (' {:>{width}} = ' +ff).format (Desc, *var2prt(var, small, rho=rho), width=width ) )
+    return None
+
 def echo (string, end='\n') :
+    '''Function to print to stdout *and* output file'''
     print ( str(string), end=end  )
     sys.stdout.flush ()
@@ -182,37 +142,45 @@
     return None
     
-## Set libIGCM directories
-R_OUT       = os.path.join ( ARCHIVE   , 'IGCM_OUT')
-R_BUF       = os.path.join ( SCRATCHDIR, 'IGCM_OUT')
-
-L_EXP = os.path.join (TagName, SpaceName, ExperimentName, JobName)
-R_SAVE      = os.path.join ( R_OUT, L_EXP )
-R_BUFR      = os.path.join ( R_BUF, L_EXP )
-POST_DIR    = os.path.join ( R_BUF, L_EXP, 'Out' )
-REBUILD_DIR = os.path.join ( R_BUF, L_EXP, 'REBUILD' )
-R_BUF_KSH   = os.path.join ( R_BUFR, 'Out' )
-R_FIGR      = os.path.join ( STORAGE, 'IGCM_OUT', L_EXP )
-    
-#if os.path.isdir (TmpDir) : shutil.rmtree ( TmpDir )
-if not os.path.isdir (TmpDir) : os.mkdir (TmpDir)
-TmpDirOCE = os.path.join (TmpDir, 'OCE')
-TmpDirICE = os.path.join (TmpDir, 'ICE')
-if not os.path.exists (TmpDirOCE) : os.mkdir (TmpDirOCE )
-if not os.path.exists (TmpDirICE) : os.mkdir (TmpDirICE )
+### Set libIGCM directories
+if wu.unDefined ('R_OUT'      ) : R_OUT       = os.path.join ( ARCHIVE   , 'IGCM_OUT' )
+if wu.unDefined ('R_BUF'      ) : R_BUF       = os.path.join ( SCRATCHDIR, 'IGCM_OUT' )
+if wu.unDefined ('L_EXP'      ) : L_EXP       = os.path.join (TagName, SpaceName, ExperimentName, JobName)
+if wu.unDefined ('R_SAVE'     ) : R_SAVE      = os.path.join ( R_OUT, L_EXP )
+if wu.unDefined ('R_BUFR'     ) : R_BUFR      = os.path.join ( R_BUF, L_EXP )
+if wu.unDefined ('POST_DIR'   ) : POST_DIR    = os.path.join ( R_BUFR, 'Out' )
+if wu.unDefined ('REBUILD_DIR') : REBUILD_DIR = os.path.join ( R_BUFR, 'REBUILD' )
+if wu.unDefined ('R_BUF_KSH'  ) : R_BUF_KSH   = os.path.join ( R_BUFR, 'Out' )
+if wu.unDefined ('R_FIGR'     ) : R_FIGR      = os.path.join ( STORAGE, 'IGCM_OUT', L_EXP )
+
+config['libIGCM'] = { 'R_OUT':R_OUT, 'R_BUF':R_BUF, 'L_EXP':L_EXP, 'R_BUFR':R_BUFR, 'POST_DIR':POST_DIR, 'REBUILD_DIR':REBUILD_DIR, 'R_BUF_KSH':R_BUF_KSH, 'R_FIGR':R_FIGR }
+
+# Set directory to extract files
+if wu.unDefined ( 'RunDir' ) : RunDir = os.path.join ( TmpDir, f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
+config['Files']['RunDir'] = RunDir
+
+if not os.path.isdir (RunDir) : os.makedirs (RunDir)
+
+# Set directories to rebuild ocean and ice restart files
+RunDirOCE = os.path.join (RunDir, 'OCE')
+RunDirICE = os.path.join (RunDir, 'ICE')
+if not os.path.exists (RunDirOCE) : os.mkdir (RunDirOCE )
+if not os.path.exists (RunDirICE) : os.mkdir (RunDirICE )
 
 echo (' ')
-echo ( f'JobName : {JobName}' )
-echo (Comment)
-echo ( f'Working in TMPDIR : {TmpDir}' )
-
-echo ( f'\nDealing with {L_EXP}' )
-
-#-- Model output directories
-if Freq == "MO" : FreqDir =  os.path.join ('Output' , 'MO' )
-if Freq == "SE" : FreqDir =  os.path.join ('Analyse', 'SE' )
-if dir_OCE_his == None :
+echo ( f'JobName   : {JobName}'   )
+echo ( f'Comment   : {Comment}'   )
+echo ( f'TmpDir    : {TmpDir}'    )
+echo ( f'RunDirOCE : {RunDirOCE}' )
+echo ( f'RunDirICE : {RunDirICE}' )
+
+echo ( f'\nDealing with {L_EXP}'  )
+
+#-- Creates model output directory names
+if Freq == "MO" : FreqDir = os.path.join ( 'Output' , 'MO' )
+if Freq == "SE" : FreqDir = os.path.join ( 'Analyse', 'SE' )
+if wu.unDefined ( 'dir_OCE_his' ) :
     dir_OCE_his = os.path.join ( R_SAVE, "OCE", FreqDir )
     config['Files']['dir_OCE_his'] = dir_OCE_his
-if dir_ICE_his == None :
+if wu.unDefined ( 'dir_ICE_his' ) :
     dir_ICE_his = os.path.join ( R_SAVE, "ICE", FreqDir )
     config['Files']['dir_OCE_his'] = dir_OCE_his
@@ -222,14 +190,14 @@
 echo ( f'{dir_ICE_his}' )
 
-#-- Files Names
-if Period == None :
+#-- Creates files names
+if wu.unDefined ( 'Period ' ) :
     if Freq == 'MO' : Period = f'{YearBegin}0101_{YearEnd}1231_1M'
     if Freq == 'SE' : Period = f'SE_{YearBegin}0101_{YearEnd}1231_1M'
     config['Files']['Period'] = Period
-if FileCommon == None :
+if wu.unDefined ( 'FileCommon' ) :
     FileCommon = f'{JobName}_{Period}'
     config['Files']['FileCommon'] = FileCommon
 
-if Title == None :
+if wu.unDefined ( 'Title' ) :
     Title = f'{JobName} : {Freq} : {YearBegin}-01-01 - {YearEnd}-12-31'
     config['Files']['Title'] = Title
@@ -237,11 +205,11 @@
         
 echo ('\nOpen history files' )
-if file_OCE_his == None :
+if wu.unDefined ('file_OCE_his' ) :
     file_OCE_his = os.path.join ( dir_OCE_his, f'{FileCommon}_grid_T.nc' )
     file_OCE_his = file_OCE_his
-if file_OCE_sca == None :    
+if wu.unDefined ('file_OCE_sca' ) :    
     file_OCE_sca = os.path.join ( dir_OCE_his, f'{FileCommon}_scalar.nc' )
     config['Files']['file_OCE_sca'] = file_OCE_sca
-if file_ICE_his == None : 
+if wu.unDefined ( 'file_ICE_hi' ) : 
     file_ICE_his = os.path.join ( dir_ICE_his, f'{FileCommon}_icemod.nc' )
     config['Files']['file_ICE_his'] = file_ICE_his
@@ -258,11 +226,11 @@
 ## Compute run length
 dtime = ( d_OCE_his.time_counter_bounds.max() - d_OCE_his.time_counter_bounds.min() )
-echo ('\nRun length : {:8.2f} days'.format ( (dtime/np.timedelta64(1, "D")).values ) )
+echo ( f'\nRun length : {(dtime/np.timedelta64(1, "D")).values:8.2f} days' )
 dtime_sec = (dtime/np.timedelta64(1, "s")).values.item() # Convert in seconds
 
 ## Compute length of each period
 dtime_per = ( d_OCE_his.time_counter_bounds[:,-1] - d_OCE_his.time_counter_bounds[:,0] )
-echo ('\nPeriods lengths (days) : ')
-echo (' {:}'.format ( (dtime_per/np.timedelta64(1, "D")).values ) )
+echo ( f'\nPeriods lengths (days) : ')
+echo ( f' {(dtime_per/np.timedelta64(1, "D")).values}' )
 dtime_per_sec = (dtime_per/np.timedelta64(1, "s")).values # In seconds
 dtime_per_sec = xr.DataArray (dtime_per_sec, dims=["time_counter", ], coords=[d_OCE_his.time_counter,] )
@@ -271,4 +239,5 @@
 ## Number of years
 NbYear = dtime_sec / YearLength
+
 #-- Open restart files
 YearRes = YearBegin - 1              # Year of the restart of beginning of simulation
@@ -277,10 +246,10 @@
 echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
 
-if TarRestartPeriod_beg == None : 
+if wu.unDefined ( 'TarRestartPeriod_beg' ) : 
     echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
     TarRestartPeriod_beg = f'{YearPre}0101_{YearRes}1231'
     config['Files']['TarRestartPeriod_beg'] = TarRestartPeriod_beg
 
-if TarRestartPeriod_end == None : 
+if wu.unDefined ( 'TarRestartPeriod_end' ) : 
     YearPre = YearBegin - PackFrequency  # Year to find the tarfile of the restart of beginning of simulation
     echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
@@ -288,25 +257,40 @@
     config['Files']['TarRestartPeriod_end'] = TarRestartPeriod_end
 
-if file_restart_beg == None :
-    file_restart_beg = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_beg}_restart.tar' )
-    config['Files']['file_restart_beg'] = file_restart_beg
-if file_restart_end == None :
-    file_restart_end = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_end}_restart.tar' )
-    config['Files']['file_restart_end'] = file_restart_end
-
-echo ( f'{file_restart_beg}' )
-echo ( f'{file_restart_end}' )
-
-if file_OCE_beg == None : 
-    file_OCE_beg = f'{TmpDir}/OCE_{JobName}_{YearRes}1231_restart.nc'
+if wu.unDefined ( 'tar_restart_beg' ) :
+    tar_restart_beg = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_beg}_restart.tar' )
+    config['Files']['tar_restart_beg'] = tar_restart_beg
+if wu.unDefined ( 'tar_restart_end' ) :
+    tar_restart_end = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_end}_restart.tar' )
+    config['Files']['tar_restart_end'] = tar_restart_end
+
+echo ( f'{tar_restart_beg}' )
+echo ( f'{tar_restart_end}' )
+
+#
+if wu.unDefined ('tar_restart_beg_ATM' ) : tar_restart_beg_ATM = tar_restart_beg
+if wu.unDefined ('tar_restart_beg_DYN' ) : tar_restart_beg_DYN = tar_restart_beg
+if wu.unDefined ('tar_restart_beg_SRF' ) : tar_restart_beg_SRF = tar_restart_beg
+if wu.unDefined ('tar_restart_beg_RUN' ) : tar_restart_beg_RUN = tar_restart_beg
+if wu.unDefined ('tar_restart_beg_OCE' ) : tar_restart_beg_OCE = tar_restart_beg
+if wu.unDefined ('tar_restart_beg_ICE' ) : tar_restart_beg_ICE = tar_restart_beg
+
+if wu.unDefined ('tar_restart_end_ATM' ) : tar_restart_end_ATM = tar_restart_end
+if wu.unDefined ('tar_restart_end_DYN' ) : tar_restart_end_DYN = tar_restart_end
+if wu.unDefined ('tar_restart_end_SRF' ) : tar_restart_end_SRF = tar_restart_end
+if wu.unDefined ('tar_restart_end_RUN' ) : tar_restart_end_RUN = tar_restart_end
+if wu.unDefined ('tar_restart_end_OCE' ) : tar_restart_end_OCE = tar_restart_end
+if wu.unDefined ('tar_restart_end_ICE' ) : tar_restart_end_ICE = tar_restart_end
+
+if wu.unDefined ( 'file_OCE_beg' ) : 
+    file_OCE_beg = f'{RunDir}/OCE_{JobName}_{YearRes}1231_restart.nc'
     config['Files']['file_OCE_beg'] = file_OCE_beg
-if file_OCE_end == None :
-    file_OCE_end = f'{TmpDir}/OCE_{JobName}_{YearEnd}1231_restart.nc'
+if wu.unDefined ( 'file_OCE_end' ) :
+    file_OCE_end = f'{RunDir}/OCE_{JobName}_{YearEnd}1231_restart.nc'
     config['Files']['file_OCE_end'] = file_OCE_end
-if file_ICE_beg == None :
-    file_ICE_beg = f'{TmpDir}/ICE_{JobName}_{YearRes}1231_restart_icemod.nc'
+if wu.unDefined ( 'file_ICE_beg' ) :
+    file_ICE_beg = f'{RunDir}/ICE_{JobName}_{YearRes}1231_restart_icemod.nc'
     config['Files']['file_ICE_beg'] = file_ICE_beg
-if file_ICE_end == None : 
-    file_ICE_end = f'{TmpDir}/ICE_{JobName}_{YearEnd}1231_restart_icemod.nc'
+if wu.unDefined ( 'file_ICE_end' ) : 
+    file_ICE_end = f'{RunDir}/ICE_{JobName}_{YearEnd}1231_restart_icemod.nc'
     config['Files']['file_ICE_end'] = file_ICE_end
 
@@ -321,76 +305,68 @@
     #ndomain_opa = d_zfile.attrs['DOMAIN_number_total']
     #d_zfile.close ()
-    ndomain_opa = subprocess.getoutput ( f'ls {zfile}_*.nc | wc -l' ).format()
+    ndomain_opa = subprocess.getoutput ( f'ls {zfile}_*.nc | wc -l' ) #.format()
     return int (ndomain_opa)
 
-if not os.path.exists ( file_OCE_beg) :
-    echo ( f'Extracting {file_OCE_beg}' )
-    base_file_OCE_beg = os.path.basename (file_OCE_beg)
-    if not os.path.exists ( os.path.join (TmpDirOCE, f'OCE_{JobName}_{YearRes}1231_restart_0000.nc') ) :
-        command =  f'cd {TmpDirOCE} ; tar xf {file_restart_beg}  OCE_{JobName}_{YearRes}1231_restart_*.nc'
-        echo ( command )
-        os.system ( command )
-    echo ('extract ndomain' )
-    ndomain_opa = get_ndomain ( os.path.join (TmpDirOCE, f'OCE_{JobName}_{YearRes}1231_restart') )
-    command = f'cd {TmpDirOCE} ; {rebuild} OCE_{JobName}_{YearRes}1231_restart {ndomain_opa} ; mv {base_file_OCE_beg} {TmpDir}'
-    echo ( command )
-    os.system ( command )
-    echo ( f'Rebuild done : {file_OCE_beg}')
-    
-if not os.path.exists ( file_OCE_end) :
-    echo ( f'Extracting {file_OCE_end}' )
-    base_file_OCE_end = os.path.basename (file_OCE_end)
-    if not os.path.exists ( os.path.join (TmpDirOCE, f'OCE_{JobName}_{YearEnd}1231_restart_0000.nc') ):
-        command =  f'cd {TmpDirOCE} ; tar xf {file_restart_end}  OCE_{JobName}_{YearEnd}1231_restart_*.nc'
-        echo ( command )
-        os.system ( command )
-    echo ('extract ndomain' )
-    ndomain_opa = get_ndomain ( os.path.join (TmpDirOCE, f'OCE_{JobName}_{YearEnd}1231_restart') )
-    command = f'cd {TmpDirOCE} ; {rebuild} OCE_{JobName}_{YearEnd}1231_restart {ndomain_opa} ; mv {base_file_OCE_end} {TmpDir}'
-    echo ( command )
-    os.system ( command )
-    echo ( f'Rebuild done : {file_OCE_end}')
-
-if not os.path.exists ( file_ICE_beg) :
-    echo ( f'Extracting {file_ICE_beg}' )
-    base_file_ICE_beg = os.path.basename (file_ICE_beg)
-    if not os.path.exists ( os.path.join (TmpDirICE, f'ICE_{JobName}_{YearRes}1231_restart_icemod_0000.nc') ):
-        command =  f'cd {TmpDirICE} ; tar xf {file_restart_beg}  ICE_{JobName}_{YearRes}1231_restart_icemod_*.nc'
-        echo ( command )
-        os.system ( command )
-    echo ('extract ndomain' )
-    ndomain_opa = get_ndomain ( os.path.join (TmpDirICE, f'ICE_{JobName}_{YearRes}1231_restart_icemod') )
-    command = f'cd {TmpDirICE} ; {rebuild} ICE_{JobName}_{YearRes}1231_restart_icemod {ndomain_opa} ; mv {base_file_ICE_beg} {TmpDir} '
-    echo ( command )
-    os.system ( command )
-    echo ( f'Rebuild done : {file_OCE_beg}')
-    
-if not os.path.exists ( file_ICE_end ) :
-    echo ( f'Extracting {file_ICE_end}' )
-    base_file_ICE_end = os.path.basename (file_ICE_end)
-    if not os.path.exists ( os.path.join (TmpDirICE, f'ICE_{JobName}_{YearEnd}1231_restart_icemod_0000.nc') ):
-        command =  f'cd {TmpDirICE} ; tar xf {file_restart_end} ICE_{JobName}_{YearEnd}1231_restart_icemod_*.nc'
-        echo ( command )
-        os.system ( command )
-    echo ('extract ndomain' )
-    ndomain_opa = get_ndomain ( os.path.join (TmpDirICE, f'ICE_{JobName}_{YearRes}1231_restart_icemod') )
-    command = f'cd {TmpDirICE} ; {rebuild} ICE_{JobName}_{YearEnd}1231_restart_icemod {ndomain_opa} ; mv {base_file_ICE_end} {TmpDir}'
-    echo ( command )
-    os.system ( command )
-    echo ( f'Rebuild done : {file_ICE_end}')
+def extract_and_rebuild ( file_name=file_OCE_beg, tar_restart=tar_restart_end, RunDirComp=RunDirOCE, ErrorCount=ErrorCount ) :
+    '''Extract restart file from tar. Rebuild ocean files if needed'''
+    echo ( f'----------')
+    if os.path.exists ( file_name ) :
+        echo ( f'-- File ready : {file_name = }' )
+    else : 
+        echo ( f'-- Extracting {file_name = }' )
+        base_resFile = Path (file_name).stem # basename, and remove suffix
+        # Try to extract the rebuilded file
+        if os.path.exists ( tar_restart ) :
+            command =  f'cd {RunDirComp} ; tar xf {tar_restart} {base_resFile}.nc'
+            echo ( command )
+            try : 
+                os.system ( command )
+            except :
+                if not os.path.exists ( os.path.join (RunDir, f'{base_resFile}_0000.nc') ):
+                    command =  f'cd {RunDirComp} ; tar xf {tar_restart_end} {base_file}_*.nc'
+                    echo ( command )
+                    ierr = os.system ( command )
+                    if ierr == 0 : echo ( f'tar done : {base_resFile}.nc')
+                    else         : raise Exception ( f'command failed : {command}' )
+                    echo ( f'extract ndomain' )
+                ndomain_opa = get_ndomain ( os.path.join (RunDir, f'{base_file}') )
+                command = f'cd {RunDirComp} ; {rebuild} {base_resFile} {ndomain_opa} ; mv {base_resFile}.nc {RunDir}'
+                echo ( command )
+                ierr = os.system ( command )
+                if ierr == 0 : echo ( f'Rebuild done : {base_resFile}.nc')
+                else         : raise Exception ( f'command failed : {command}' )
+            else : 
+                echo ( f'tar done : {base_resFile}')
+                command = f'cd {RunDirComp} ; mv {base_resFile}.nc {RunDir}'
+                ierr = os.system ( command )
+                if ierr == 0 : echo ( f'command done : {command}' )
+                else         : raise Exception ( f'command failed : {command = }' )                   
+        else :
+            echo ( f'****** Tar restart file {tar_restart = } not found ' )
+            if ContinueOnError :
+                ErrorCount += 1
+            else : 
+                raise Exception ( f'****** tar file not found {tar_restart = } - Stopping' )
+    return ErrorCount
+
+            
+ErrorCount += extract_and_rebuild ( file_name=file_OCE_beg, tar_restart=tar_restart_beg, RunDirComp=RunDirOCE )
+ErrorCount += extract_and_rebuild ( file_name=file_OCE_end, tar_restart=tar_restart_end, RunDirComp=RunDirOCE )
+ErrorCount += extract_and_rebuild ( file_name=file_ICE_beg, tar_restart=tar_restart_beg, RunDirComp=RunDirICE )
+ErrorCount += extract_and_rebuild ( file_name=file_ICE_end, tar_restart=tar_restart_end, RunDirComp=RunDirICE )
 
 echo ('Opening OCE and ICE restart files')
 if NEMO == 3.6 : 
-    d_OCE_beg = xr.open_dataset ( os.path.join (TmpDir, file_OCE_beg), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-    d_OCE_end = xr.open_dataset ( os.path.join (TmpDir, file_OCE_end), decode_times=False, decode_cf=True).squeeze()
-    d_ICE_beg = xr.open_dataset ( os.path.join (TmpDir, file_ICE_beg), decode_times=False, decode_cf=True).squeeze()
-    d_ICE_end = xr.open_dataset ( os.path.join (TmpDir, file_ICE_end), decode_times=False, decode_cf=True).squeeze()
+    d_OCE_beg = xr.open_dataset ( os.path.join (RunDir, file_OCE_beg), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
+    d_OCE_end = xr.open_dataset ( os.path.join (RunDir, file_OCE_end), decode_times=False, decode_cf=True).squeeze()
+    d_ICE_beg = xr.open_dataset ( os.path.join (RunDir, file_ICE_beg), decode_times=False, decode_cf=True).squeeze()
+    d_ICE_end = xr.open_dataset ( os.path.join (RunDir, file_ICE_end), decode_times=False, decode_cf=True).squeeze()
 if NEMO == 4.0 or NEMO == 4.2 : 
-    d_OCE_beg = xr.open_dataset ( os.path.join (TmpDir, file_OCE_beg), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-    d_OCE_end = xr.open_dataset ( os.path.join (TmpDir, file_OCE_end), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-    d_ICE_beg = xr.open_dataset ( os.path.join (TmpDir, file_ICE_beg), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-    d_ICE_end = xr.open_dataset ( os.path.join (TmpDir, file_ICE_end), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-
-##
+    d_OCE_beg = xr.open_dataset ( os.path.join (RunDir, file_OCE_beg), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
+    d_OCE_end = xr.open_dataset ( os.path.join (RunDir, file_OCE_end), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
+    d_ICE_beg = xr.open_dataset ( os.path.join (RunDir, file_ICE_beg), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
+    d_ICE_end = xr.open_dataset ( os.path.join (RunDir, file_ICE_end), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
+
+## Write the full configuration
 config_out = open (FullIniFile, 'w')
 config.write (config_out )
@@ -473,10 +449,10 @@
     OCE_sum_e3tn_end = OCE_stock_int ( OCE_e3tn_end * OCE_msk3)
 
-echo ( 'OCE_sum_ssh_beg = {:12.6e} m^3  - OCE_sum_ssh_end = {:12.6e} m^3'.format (OCE_sum_ssh_beg, OCE_sum_ssh_end) )
+echo ( f'OCE_sum_ssh_beg = {OCE_sum_ssh_beg:12.6e} m^3  - OCE_sum_ssh_end = {OCE_sum_ssh_end:12.6e} m^3' )
 dOCE_ssh_vol = ( OCE_sum_ssh_end - OCE_sum_ssh_beg )
 dOCE_ssh_mas = dOCE_ssh_vol * OCE_rho_liq
 
 if NEMO == 3.6 :
-    echo ( 'OCE_sum_e3tn_beg = {:12.6e} m^3  - OCE_sum_e3tn_end = {:12.6e} m^3'.format (OCE_sum_e3tn_beg, OCE_sum_e3tn_end) )
+    echo ( f'OCE_sum_e3tn_beg = {OCE_sum_e3tn_beg:12.6e} m^3  - OCE_sum_e3tn_end = {OCE_sum_e3tn_end:12.6e} m^3' )
     dOCE_e3tn_vol = ( OCE_sum_e3tn_end - OCE_sum_e3tn_beg )
     dOCE_e3tn_mas = dOCE_e3tn_vol * OCE_rho_liq
@@ -484,10 +460,10 @@
 dOCE_vol_wat = dOCE_ssh_vol ; dOCE_mas_wat = dOCE_ssh_mas
 
-echo ( 'dOCE vol    = {:12.3e} m^3'.format ( dOCE_vol_wat) )
-echo ( 'dOCE ssh    = {:12.3e} m  '.format ( dOCE_vol_wat/OCE_aire_tot) )
+echo ( f'dOCE vol    = {dOCE_vol_wat             :12.3e} m^3' )
+echo ( f'dOCE ssh    = {dOCE_vol_wat/OCE_aire_tot:12.3e} m  ' )
 prtFlux ( 'dOCE mass ', dOCE_mas_wat, 'e' )
 
 if NEMO == 3.6 :
-    echo ( 'dOCE e3tn   vol    = {:12.3e} m^3'.format ( dOCE_e3tn_vol) )
+    echo ( f'dOCE e3tn   vol    = {dOCE_e3tn_vol:12.3e} m^3' )
     prtFlux ( 'dOCE e3tn   mass', dOCE_e3tn_mas, 'e' )
 
